import  { 
	select, 
	arc, 
 	csv, 
 	scaleLinear, 
 	max, 
  min,
 	scalePoint, 
 	axisLeft,
 	axisBottom,
  format,
  extent
  } from 'd3';

const svg = select('svg')

const heigth = +svg.attr('height')
const width = +svg.attr('width')

const render = data => {
  const title = 'Cars: Horsepowers vs Weight'
  const xValue = d => d.horsepower
  const yValue = d => d.weight
  const xAxisLabel = 'Horsepower'
  const yAxisLabel = 'Weight'
  const circleRadius = 7
  const margin =  { top: 50, right:40, bottom: 110, left: 180}
  const innerWidth = width - margin.left - margin.right
  const innerHeight = heigth - margin.top - margin.bottom
  
  const xScale = scaleLinear()
  	.domain([min(data, xValue), max(data, xValue)])
    .range([0, innerWidth])
  	.nice()
  
  const yScale = scaleLinear()
  	.domain([min(data, yValue), max(data, yValue)])
    .range([0, innerHeight])
  	.nice()
  
  const g = svg.append('g')
  	.attr('transform', `translate(${margin.left}, ${margin.top})`)
  
                                   
  const xAxis = axisBottom(xScale)
  	.tickSize(-innerHeight)
  	.tickPadding(20)
  
  const yAxis = axisLeft(yScale)
  	.tickSize(-innerWidth)
  	.tickPadding(10)
  
  const yAxisG = g.append('g').call(yAxis)
  yAxisG.selectAll('.domain ').remove();
  
  yAxisG.append('text')
  	.attr('class', 'axis-label')
  	.attr('y',-85)
  	.attr('x',  -innerHeight / 2)
    .attr('fill','black')
  	.attr('transform','rotate(-90)')
  	.attr('text-anchor','middle')
    .text(yAxisLabel)
  
  const xAxisG = g.append('g').call(xAxis)
  	.attr('transform', `translate(0, ${innerHeight})`)
  
  xAxisG.select('.domain').remove();
  xAxisG.append('text')
  	.attr('class', 'axis-label')
  	.attr('y',75)
  	.attr('x',innerWidth /2)
    .attr('fill','black')
    .text(xAxisLabel)
  
 	g.selectAll('circle').data(data) 
    .enter().append('circle')
  		.attr('cy', d => yScale(yValue(d)) )
      .attr('cx', d => xScale(xValue(d)))
      .attr('r',circleRadius);
  
  g.append('text')
  	.attr('class', 'title')
  	.attr('y',-5)
    .text(title)
};

csv('https://vizhub.com/curran/datasets/auto-mpg.csv')
  .then(data => {
    data.forEach(d => {
      d.mpg = +d.mpg;
      d.cylinders = +d.cylinders;
      d.displacement = +d.displacement;
      d.horsepower = +d.horsepower;
      d.weight = +d.weight;
      d.acceleration = +d.acceleration;
      d.year = +d.year;  
    });
    render(data);
  });














    